package com.exploitpack.main;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.widgets.Composite;

public class Reports {

	protected Shell shlExploitPack;
	private Text reportlog;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			Reports window = new Reports();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		Rectangle bounds = display.getBounds();
		Rectangle rect = shlExploitPack.getBounds();

		int x = bounds.x + (bounds.width - rect.width) / 2;
		int y = bounds.y + (bounds.height - rect.height) / 2;

		shlExploitPack.setLocation(x, y);
		
		Label lblNewLabel = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel.setImage(SWTResourceManager.getImage(Reports.class, "/resources/about2.png"));
		lblNewLabel.setBounds(10, 10, 124, 250);
		
		Label lblLogReport = new Label(shlExploitPack, SWT.NONE);
		lblLogReport.setBounds(140, 10, 385, 15);
		lblLogReport.setText("This report log represents a security audit performed by Exploit Pack:\r\n");
		
		Composite composite = new Composite(shlExploitPack, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setBounds(10, 10, 124, 445);
		
		Label lblNewLabel_1 = new Label(composite, SWT.NONE);
		lblNewLabel_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		lblNewLabel_1.setBounds(10, 420, 104, 15);
		lblNewLabel_1.setText("Session logs report");
		
		Label lblNewLabel_2 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_2.setBounds(10, 470, 445, 15);
		lblNewLabel_2.setText("Access to this data by unauthorized people may allow to compromise your network");
		shlExploitPack.open();
		shlExploitPack.layout();
		while (!shlExploitPack.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlExploitPack = new Shell();
		shlExploitPack.setSize(562, 538);
		shlExploitPack.setText("Exploit Pack - Log Report");
		reportlog = new Text(shlExploitPack, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		reportlog.setBounds(140, 31, 396, 424);

		Button btnNewButton = new Button(shlExploitPack, SWT.NONE);
		btnNewButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				shlExploitPack.dispose();
			}
		});
		btnNewButton.setBounds(461, 465, 75, 25);
		btnNewButton.setText("Close");

		// Load report from file
		try{
			  // Open the file that is the first 
			  // command line parameter
			  FileInputStream fstream = new FileInputStream("log/exploitpack.log");
			  // Get the object of DataInputStream
			  DataInputStream in = new DataInputStream(fstream);
			  BufferedReader br = new BufferedReader(new InputStreamReader(in));
			  String strLine;
			  //Read File Line By Line
			  while ((strLine = br.readLine()) != null)   {
			  // Print the content on the console
			  reportlog.append(strLine + "\n");
			  }
			  //Close the input stream
			  in.close();
			    }catch (Exception e){
			  //Catch exception if any
			  System.err.println("Error: " + e.getMessage());
			  }

	}
}
