/**
Exploit Pack - Security Framework for Exploit Developers
Copyright 2012 Juan Sacco http://exploitpack.com

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software Foundation, either version 3 
or any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. 
If not, see http://www.gnu.org/licenses/
 **/

package com.exploitpack.project;
import java.io.BufferedWriter;
import java.io.FileWriter;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.DateTime;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;


public class ProjectWindow {

	protected Shell shlExploitPack;
	private Text ProjectName;
	private Text TargetIpHost;
	private Text CompanyName;
	private Text ContactName;
	private Text ContactPhone;
	private Text ContactEmail;
	private Text ContactWebsite;
	private DateTime DateWorkStart;
	private DateTime DateWorkEnd;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			ProjectWindow window = new ProjectWindow();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		Rectangle bounds = display.getBounds();
		Rectangle rect = shlExploitPack.getBounds();

		int x = bounds.x + (bounds.width - rect.width) / 2;
		int y = bounds.y + (bounds.height - rect.height) / 2;

		shlExploitPack.setLocation(x, y);
		
		Label lblNewLabel_10 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_10.setImage(SWTResourceManager.getImage(ProjectWindow.class, "/resources/up.png"));
		lblNewLabel_10.setBounds(0, 0, 527, 57);
		
		Label label = new Label(shlExploitPack, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setBounds(0, 58, 527, 2);
		    
		shlExploitPack.open();
		shlExploitPack.layout();
		while (!shlExploitPack.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlExploitPack = new Shell();
		shlExploitPack.setImage(SWTResourceManager.getImage(ProjectWindow.class, "/resources/1316133906_package.png"));
		shlExploitPack.setSize(532, 461);
		shlExploitPack.setText("Exploit Pack - New Project");
		
		Button btnBack = new Button(shlExploitPack, SWT.NONE);
		btnBack.setEnabled(false);
		btnBack.setBounds(271, 394, 68, 23);
		btnBack.setText("Back");
		
		Button btnCancel = new Button(shlExploitPack, SWT.NONE);
		btnCancel.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				ProjectWindow.this.shlExploitPack.dispose();
			}
		});
		btnCancel.setBounds(435, 394, 68, 23);
		btnCancel.setText("Cancel");
		
		Label label = new Label(shlExploitPack, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setBounds(0, 383, 527, 2);
		
		ProjectName = new Text(shlExploitPack, SWT.BORDER);
		ProjectName.setBounds(207, 111, 206, 23);
		
		TargetIpHost = new Text(shlExploitPack, SWT.BORDER);
		TargetIpHost.setBounds(207, 151, 188, 23);
		
		CompanyName = new Text(shlExploitPack, SWT.BORDER);
		CompanyName.setBounds(207, 180, 188, 23);
		
		ContactName = new Text(shlExploitPack, SWT.BORDER);
		ContactName.setBounds(207, 209, 188, 23);
		
		ContactPhone = new Text(shlExploitPack, SWT.BORDER);
		ContactPhone.setBounds(215, 246, 180, 23);
		
		ContactEmail = new Text(shlExploitPack, SWT.BORDER);
		ContactEmail.setBounds(215, 275, 180, 23);
		
		ContactWebsite = new Text(shlExploitPack, SWT.BORDER);
		ContactWebsite.setBounds(215, 304, 180, 23);
		
		Label lblNewLabel = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel.setBounds(63, 107, 138, 23);
		lblNewLabel.setText("New project name :");
		
		Label lblNewLabel_1 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_1.setBounds(63, 151, 131, 23);
		lblNewLabel_1.setText("Target - IP / Host :");
		
		Label lblNewLabel_2 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_2.setBounds(63, 176, 138, 23);
		lblNewLabel_2.setText("Company name :");
		
		Label lblNewLabel_3 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_3.setBounds(63, 201, 131, 23);
		lblNewLabel_3.setText("Contact name :");
		
		Label lblNewLabel_4 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_4.setBounds(63, 226, 138, 23);
		lblNewLabel_4.setText("Phone number :");
		
		Label lblNewLabel_5 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_5.setBounds(63, 251, 138, 23);
		lblNewLabel_5.setText("Email address:");
		
		Label lblNewLabel_6 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_6.setBounds(63, 275, 138, 23);
		lblNewLabel_6.setText("Web site :");
		
		Label lblNewLabel_7 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_7.setBounds(63, 304, 131, 23);
		lblNewLabel_7.setText("Work period :");
		
		Label lblNewLabel_8 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_8.setBounds(63, 346, 39, 31);
		lblNewLabel_8.setText("Start :");
		
		Label lblNewLabel_9 = new Label(shlExploitPack, SWT.NONE);
		lblNewLabel_9.setBounds(293, 346, 46, 31);
		lblNewLabel_9.setText("End :");
		
		DateWorkStart = new DateTime(shlExploitPack, SWT.BORDER);
		DateWorkStart.setBounds(132, 346, 124, 23);
		
		DateWorkEnd = new DateTime(shlExploitPack, SWT.BORDER);
		DateWorkEnd.setBounds(350, 346, 124, 23);
		
		Button btnNext = new Button(shlExploitPack, SWT.NONE);
		btnNext.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {

				 try{
					  // Create file 
					  FileWriter fstream = new FileWriter("log/Sessions.log");
					  BufferedWriter out = new BufferedWriter(fstream);
					  out.append("Project name: " + ProjectName.getText() + "\r\n");
					  out.append("Target Host: " + TargetIpHost.getText() + "\r\n");
					  out.append("Company Name: " + CompanyName.getText() + "\r\n"); 
					  out.append("Contact Name: " + ContactName.getText() + "\r\n"); 
					  out.append("Contact Phone: " + ContactPhone.getText() + "\r\n");
					  out.append("Contact Email: " + ContactEmail.getText() + "\r\n");
					  out.append("Contact Website: " + ContactWebsite.getText() + "\r\n");
     				  out.append("Work Start: " + DateWorkStart.getYear() + "/" + DateWorkStart.getMonth() +"/" + DateWorkStart.getDay() + "\r\n");// ADD DATE PICKER
					  out.append("Work Ends: "  + DateWorkEnd.getYear() + "/" + DateWorkEnd.getMonth() + "/" + DateWorkEnd.getDay() + "\r\n");// ADD DATE PICKER
					  //Close the output stream
					  out.close();
					  }catch (Exception e1){
					  System.err.println("Error: " + e1.getMessage());
					  }
				 ProjectWindow.this.shlExploitPack.dispose();
				 ProjectWindow2.main(null);

			}
		});
		btnNext.setBounds(345, 394, 68, 23);
		btnNext.setText("Next");

	}
}
